'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var _Promise = _interopDefault(require('babel-runtime/core-js/promise'));
var _regeneratorRuntime = _interopDefault(require('babel-runtime/regenerator'));
var _asyncToGenerator = _interopDefault(require('babel-runtime/helpers/asyncToGenerator'));
var _extends = _interopDefault(require('babel-runtime/helpers/extends'));
var _toConsumableArray = _interopDefault(require('babel-runtime/helpers/toConsumableArray'));
var _Object$keys = _interopDefault(require('babel-runtime/core-js/object/keys'));
var gulpUtil = require('gulp-util');
var through = _interopDefault(require('through2'));
var Cache = _interopDefault(require('cache-swap'));
var File = _interopDefault(require('vinyl'));
var pick = _interopDefault(require('object.pick'));
var _JSON$stringify = _interopDefault(require('babel-runtime/core-js/json/stringify'));
var _Object$assign = _interopDefault(require('babel-runtime/core-js/object/assign'));
var _defineProperty = _interopDefault(require('babel-runtime/helpers/defineProperty'));
var _slicedToArray = _interopDefault(require('babel-runtime/helpers/slicedToArray'));
var _Array$from = _interopDefault(require('babel-runtime/core-js/array/from'));
var _Reflect$apply = _interopDefault(require('babel-runtime/core-js/reflect/apply'));
var _Map = _interopDefault(require('babel-runtime/core-js/map'));
var _classCallCheck = _interopDefault(require('babel-runtime/helpers/classCallCheck'));
var _createClass = _interopDefault(require('babel-runtime/helpers/createClass'));
var EventEmitter = _interopDefault(require('events'));
var crypto = _interopDefault(require('crypto'));

function makeHash(key) {
	return crypto.createHash('md5').update(key).digest('hex');
}

var TaskProxy = function () {
	function TaskProxy(task, inputOptions) {
		_classCallCheck(this, TaskProxy);

		this.task = task;
		this.options = inputOptions;
		this._cacheQueue = new _Map();
		this._removeListeners = [];

		if (task) {
			this.patchTask();
		}
	}

	_createClass(TaskProxy, [{
		key: 'patchTask',
		value: function patchTask() {
			var task = this.task,
			    _transform = task._transform;


			task._transform = function (chunk, encoding, next) {

				_Reflect$apply(_transform, task, [chunk, encoding, function () {
					next.apply(undefined, arguments); // eslint-disable-line
					task.emit('gulp-cache:transformed');
				}]);
			};
		}
	}, {
		key: 'processFile',
		value: function processFile(inputFile) {
			var _this = this;

			var signals = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new EventEmitter();


			process.nextTick(function () {
				_this._processFileAsync(inputFile, signals);
			});

			return signals;
		}
	}, {
		key: '_processFileAsync',
		value: function () {
			var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(inputFile) {
				var signals = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new EventEmitter();
				var cached, cachedValue, cachedValueNotEmpty, cachedValueHasNormalPaths;
				return _regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.next = 2;
								return this._checkForCachedValue(inputFile);

							case 2:
								cached = _context.sent;


								// If we found a cached value
								// The path of the cache key should also be identical to the original one when the file path changed inside the task
								cachedValue = cached.value, cachedValueNotEmpty = Array.isArray(cachedValue) && cachedValue.length;
								cachedValueHasNormalPaths = cachedValueNotEmpty && cachedValue.every(function (file) {
									return (!file.gulpCache$filePathChangedInsideTask || file.gulpCache$originalPath === inputFile.path) && (!file.gulpCache$fileBaseChangedInsideTask || file.gulpCache$originalBase === inputFile.base);
								});

								if (!cachedValueHasNormalPaths) {
									_context.next = 10;
									break;
								}

								cachedValue.forEach(function (cachedFile) {
									// Extend the cached value onto the file, but don't overwrite original path info
									var file = new File(_extends({}, cachedFile, pick(inputFile, ['cwd', 'base', 'stat', 'history', 'path']), {
										// file contents
										contents: cachedFile.contents
									}));

									// Restore the file path if it was set
									if (cachedFile.path && cachedFile.gulpCache$filePathChangedInsideTask) {
										file.path = cachedFile.path;
									}
									// Restore the file base if it was set
									if (cachedFile.base && cachedFile.gulpCache$fileBaseChangedInsideTask) {
										file.base = cachedFile.base;
									}

									signals.emit('file', file);
								});

								signals.emit('done');

								this._removeListeners.push(function () {
									// Remove all listeners from `signals`
									signals.removeAllListeners();
								});

								return _context.abrupt('return');

							case 10:

								this._runProxiedTaskAndQueueCache(inputFile, cached.key, signals);

							case 11:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function _processFileAsync(_x2) {
				return _ref.apply(this, arguments);
			}

			return _processFileAsync;
		}()
	}, {
		key: 'flush',
		value: function () {
			var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(next) {
				var _this2 = this;

				var task;
				return _regeneratorRuntime.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								task = this.task;
								_context3.prev = 1;

								if (!(typeof task._flush == 'function')) {
									_context3.next = 6;
									break;
								}

								task._flush(function () {
									var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2() {
										var _args2 = arguments;
										return _regeneratorRuntime.wrap(function _callee2$(_context2) {
											while (1) {
												switch (_context2.prev = _context2.next) {
													case 0:
														_context2.next = 2;
														return _this2._flush();

													case 2:
														next.apply(undefined, _args2);

													case 3:
													case 'end':
														return _context2.stop();
												}
											}
										}, _callee2, _this2);
									}));

									return function () {
										return _ref3.apply(this, arguments);
									};
								}());
								_context3.next = 10;
								break;

							case 6:
								_context3.next = 8;
								return this._flush();

							case 8:
								next();
								return _context3.abrupt('return');

							case 10:
								_context3.next = 16;
								break;

							case 12:
								_context3.prev = 12;
								_context3.t0 = _context3['catch'](1);

								next(_context3.t0);
								return _context3.abrupt('return');

							case 16:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, this, [[1, 12]]);
			}));

			function flush(_x4) {
				return _ref2.apply(this, arguments);
			}

			return flush;
		}()
	}, {
		key: '_flush',
		value: function () {
			var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
				var _this3 = this;

				return _regeneratorRuntime.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:

								this._removeListeners.forEach(function (remove) {
									remove();
								});

								this._removeListeners = [];

								_context5.next = 4;
								return _Promise.all(_Array$from(this._cacheQueue).map(function () {
									var _ref5 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(_ref6) {
										var _ref7 = _slicedToArray(_ref6, 2),
										    cachedKey = _ref7[0],
										    files = _ref7[1];

										return _regeneratorRuntime.wrap(function _callee4$(_context4) {
											while (1) {
												switch (_context4.prev = _context4.next) {
													case 0:
														return _context4.abrupt('return', _this3._storeCachedResult(cachedKey, files));

													case 1:
													case 'end':
														return _context4.stop();
												}
											}
										}, _callee4, _this3);
									}));

									return function (_x5) {
										return _ref5.apply(this, arguments);
									};
								}()));

							case 4:

								this._cacheQueue = new _Map();

							case 5:
							case 'end':
								return _context5.stop();
						}
					}
				}, _callee5, this);
			}));

			function _flush() {
				return _ref4.apply(this, arguments);
			}

			return _flush;
		}()
	}, {
		key: 'removeCachedResult',
		value: function () {
			var _ref8 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6(file) {
				var cachedKey;
				return _regeneratorRuntime.wrap(function _callee6$(_context6) {
					while (1) {
						switch (_context6.prev = _context6.next) {
							case 0:
								_context6.next = 2;
								return this._getFileKey(file);

							case 2:
								cachedKey = _context6.sent;
								return _context6.abrupt('return', this._removeCached(this.options.name, cachedKey));

							case 4:
							case 'end':
								return _context6.stop();
						}
					}
				}, _callee6, this);
			}));

			function removeCachedResult(_x6) {
				return _ref8.apply(this, arguments);
			}

			return removeCachedResult;
		}()
	}, {
		key: '_getFileKey',
		value: function () {
			var _ref9 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7(file) {
				var getKey, key;
				return _regeneratorRuntime.wrap(function _callee7$(_context7) {
					while (1) {
						switch (_context7.prev = _context7.next) {
							case 0:
								getKey = this.options.key;
								_context7.next = 3;
								return getKey(file);

							case 3:
								key = _context7.sent;
								return _context7.abrupt('return', key ? makeHash(key) : key);

							case 5:
							case 'end':
								return _context7.stop();
						}
					}
				}, _callee7, this);
			}));

			function _getFileKey(_x7) {
				return _ref9.apply(this, arguments);
			}

			return _getFileKey;
		}()
	}, {
		key: '_checkForCachedValue',
		value: function () {
			var _ref10 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee8(file) {
				var key, _options, cacheName, restore, cached, parsedContents;

				return _regeneratorRuntime.wrap(function _callee8$(_context8) {
					while (1) {
						switch (_context8.prev = _context8.next) {
							case 0:
								_context8.next = 2;
								return this._getFileKey(file);

							case 2:
								key = _context8.sent;

								if (key) {
									_context8.next = 5;
									break;
								}

								return _context8.abrupt('return', {
									value: null,
									key: key
								});

							case 5:
								_options = this.options, cacheName = _options.name, restore = _options.restore;
								_context8.next = 8;
								return this._getCached(cacheName, key);

							case 8:
								cached = _context8.sent;

								if (cached) {
									_context8.next = 11;
									break;
								}

								return _context8.abrupt('return', {
									value: null,
									key: key
								});

							case 11:
								parsedContents = null;


								try {
									parsedContents = JSON.parse(cached.contents);
								} catch (err) {
									parsedContents = [{ cached: cached.contents }];
								}

								if (restore) {
									parsedContents = parsedContents.map(function (parsedFile) {

										var restoredFile = restore(parsedFile);

										// Force restore service properties
										restoredFile.gulpCache$filePathChangedInsideTask = parsedFile.gulpCache$filePathChangedInsideTask;
										restoredFile.gulpCache$fileBaseChangedInsideTask = parsedFile.gulpCache$fileBaseChangedInsideTask;
										restoredFile.gulpCache$originalPath = parsedFile.gulpCache$originalPath;
										restoredFile.gulpCache$originalBase = parsedFile.gulpCache$originalBase;

										return restoredFile;
									});
								}

								return _context8.abrupt('return', {
									value: parsedContents,
									key: key
								});

							case 15:
							case 'end':
								return _context8.stop();
						}
					}
				}, _callee8, this);
			}));

			function _checkForCachedValue(_x8) {
				return _ref10.apply(this, arguments);
			}

			return _checkForCachedValue;
		}()
	}, {
		key: '_getValueFromResult',
		value: function () {
			var _ref11 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee9(result) {
				var getValue;
				return _regeneratorRuntime.wrap(function _callee9$(_context9) {
					while (1) {
						switch (_context9.prev = _context9.next) {
							case 0:
								getValue = this.options.value;

								if (!(typeof getValue !== 'function')) {
									_context9.next = 5;
									break;
								}

								if (!(typeof getValue === 'string')) {
									_context9.next = 4;
									break;
								}

								return _context9.abrupt('return', _defineProperty({}, getValue, result[getValue]));

							case 4:
								return _context9.abrupt('return', getValue);

							case 5:
								return _context9.abrupt('return', getValue(result));

							case 6:
							case 'end':
								return _context9.stop();
						}
					}
				}, _callee9, this);
			}));

			function _getValueFromResult(_x9) {
				return _ref11.apply(this, arguments);
			}

			return _getValueFromResult;
		}()
	}, {
		key: '_storeCachedResult',
		value: function () {
			var _ref13 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee11(key, result) {
				var _this4 = this;

				var options, files;
				return _regeneratorRuntime.wrap(function _callee11$(_context11) {
					while (1) {
						switch (_context11.prev = _context11.next) {
							case 0:
								if (key) {
									_context11.next = 2;
									break;
								}

								return _context11.abrupt('return', result);

							case 2:
								options = this.options;
								_context11.next = 5;
								return _Promise.all(result.map(function () {
									var _ref14 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee10(_ref15) {
										var file = _ref15.file,
										    meta = _ref15.meta;
										return _regeneratorRuntime.wrap(function _callee10$(_context10) {
											while (1) {
												switch (_context10.prev = _context10.next) {
													case 0:
														_context10.t0 = options.success !== true;

														if (!_context10.t0) {
															_context10.next = 5;
															break;
														}

														_context10.next = 4;
														return options.success(file);

													case 4:
														_context10.t0 = !_context10.sent;

													case 5:
														if (!_context10.t0) {
															_context10.next = 7;
															break;
														}

														return _context10.abrupt('return', null);

													case 7:
														_context10.t1 = _Object$assign;
														_context10.next = 10;
														return _this4._getValueFromResult(file);

													case 10:
														_context10.t2 = _context10.sent;
														_context10.t3 = meta;
														return _context10.abrupt('return', (0, _context10.t1)(_context10.t2, _context10.t3));

													case 13:
													case 'end':
														return _context10.stop();
												}
											}
										}, _callee10, _this4);
									}));

									return function (_x12) {
										return _ref14.apply(this, arguments);
									};
								}()));

							case 5:
								_context11.t0 = Boolean;
								files = _context11.sent.filter(_context11.t0);
								return _context11.abrupt('return', this._addCached(this.options.name, key, _JSON$stringify(files, null, 2)));

							case 8:
							case 'end':
								return _context11.stop();
						}
					}
				}, _callee11, this);
			}));

			function _storeCachedResult(_x10, _x11) {
				return _ref13.apply(this, arguments);
			}

			return _storeCachedResult;
		}()
	}, {
		key: '_queueCache',
		value: function () {
			var _ref16 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee12(file, cachedKey, originalBase, originalPath) {
				var _cacheQueue, item;

				return _regeneratorRuntime.wrap(function _callee12$(_context12) {
					while (1) {
						switch (_context12.prev = _context12.next) {
							case 0:
								_cacheQueue = this._cacheQueue;
								item = {
									file: file.clone({ contents: false }),
									meta: {
										// Check if the task changed the file path
										gulpCache$filePathChangedInsideTask: file.path !== originalPath,
										// Check if the task changed the base path
										gulpCache$fileBaseChangedInsideTask: file.base !== originalBase,
										// Keep track of the original path
										gulpCache$originalPath: originalPath,
										// Keep track of the original base
										gulpCache$originalBase: originalBase
									}
								};


								if (_cacheQueue.has(cachedKey)) {
									_cacheQueue.get(cachedKey).push(item);
								} else {
									_cacheQueue.set(cachedKey, [item]);
								}

							case 3:
							case 'end':
								return _context12.stop();
						}
					}
				}, _callee12, this);
			}));

			function _queueCache(_x13, _x14, _x15, _x16) {
				return _ref16.apply(this, arguments);
			}

			return _queueCache;
		}()
	}, {
		key: '_runProxiedTaskAndQueueCache',
		value: function _runProxiedTaskAndQueueCache(file, cachedKey) {
			var _this5 = this;

			var signals = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new EventEmitter();


			var originalBase = file.base,
			    originalPath = file.path;

			signals.on('cache', function (file) {
				_this5._queueCache(file, cachedKey, originalBase, originalPath);
				signals.emit('file', file);
			});

			return this._runProxiedTask(file, cachedKey, signals);
		}
	}, {
		key: '_runProxiedTask',
		value: function _runProxiedTask(file, cachedKey) {
			var signals = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new EventEmitter();
			var task = this.task,
			    hasCacheListener = Boolean(signals.listenerCount('cache'));


			function onError(err) {
				signals.emit('error', err);
			}

			function onData(datum) {

				if (datum._cachedKey !== cachedKey) {
					return;
				}

				if (hasCacheListener) {
					signals.emit('cache', datum);
				} else {
					signals.emit('file', datum);
				}
			}

			function onTransformed() {
				signals.emit('done');
			}

			this._removeListeners.push(function () {
				// Be good citizens and remove our listeners
				task.removeListener('error', onError);
				task.removeListener('gulp-cache:transformed', onTransformed);
				task.removeListener('data', onData);

				// Reduce the maxListeners back down
				task.setMaxListeners(task._maxListeners - 3);

				// Remove all listeners from `signals`
				signals.removeAllListeners();
			});

			// Bump up max listeners to prevent memory leak warnings
			var currMaxListeners = task._maxListeners || 0;

			task.setMaxListeners(currMaxListeners + 3);

			task.on('data', onData);
			task.once('gulp-cache:transformed', onTransformed);
			task.once('error', onError);

			file._cachedKey = cachedKey;

			// Run through the other task and grab output (or error)
			task.write(file);

			return signals;
		}

		/**
   * Cache promise wrappers.
   */

	}, {
		key: '_addCached',
		value: function _addCached() {
			var _this6 = this;

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return new _Promise(function (resolve, reject) {
				var _options$fileCache;

				(_options$fileCache = _this6.options.fileCache).addCached.apply(_options$fileCache, args.concat([function (err, res) {

					if (err) {
						reject(err);
						return;
					}

					resolve(res);
				}]));
			});
		}
	}, {
		key: '_getCached',
		value: function _getCached() {
			var _this7 = this;

			for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
				args[_key2] = arguments[_key2];
			}

			return new _Promise(function (resolve, reject) {
				var _options$fileCache2;

				(_options$fileCache2 = _this7.options.fileCache).getCached.apply(_options$fileCache2, args.concat([function (err, res) {

					if (err) {
						reject(err);
						return;
					}

					resolve(res);
				}]));
			});
		}
	}, {
		key: '_removeCached',
		value: function _removeCached() {
			var _this8 = this;

			for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
				args[_key3] = arguments[_key3];
			}

			return new _Promise(function (resolve, reject) {
				var _options$fileCache3;

				(_options$fileCache3 = _this8.options.fileCache).removeCached.apply(_options$fileCache3, args.concat([function (err) {

					if (err) {
						reject(err);
						return;
					}

					resolve();
				}]));
			});
		}
	}]);

	return TaskProxy;
}();

module.exports = exports['default'];

var version = "1.0.0";

var fileCache = new Cache({ cacheDirName: 'gulp-cache' });

function defaultKey(file) {
	return '' + version + file.contents.toString('base64');
}

function defaultRestore(restored) {

	if (restored.contents) {
		// Handle node 0.11 buffer to JSON as object with { type: 'buffer', data: [...] }
		if (restored && restored.contents && Array.isArray(restored.contents.data)) {
			restored.contents = new Buffer(restored.contents.data);
		} else if (Array.isArray(restored.contents)) {
			restored.contents = new Buffer(restored.contents);
		} else if (typeof restored.contents === 'string') {
			restored.contents = new Buffer(restored.contents, 'base64');
		}
	}

	var restoredFile = new File(restored);

	// Restore any properties that the original task put on the file;
	// but omit the normal properties of the file
	_Object$keys(restored).forEach(function (key) {

		if (File.isCustomProp(key)) {
			restoredFile[key] = restored[key];
		}
	});

	return restoredFile;
}

function defaultValue(file) {

	var vinylProps = ['cwd', 'base', 'contents', 'stat', 'history', 'path'],
	    customProps = _Object$keys(file).filter(File.isCustomProp);

	// Convert from a File object (from vinyl) into a plain object
	return pick(file, [].concat(vinylProps, _toConsumableArray(customProps)));
}

var defaultOptions = {
	fileCache: fileCache,
	name: 'default',
	success: true,
	key: defaultKey,
	restore: defaultRestore,
	value: defaultValue
};

plugin.Cache = Cache;
plugin.fileCache = fileCache;
plugin.defaultOptions = defaultOptions;

function plugin(task, inputOptions) {
	// Check for required task option
	if (!task) {
		throw new gulpUtil.PluginError('gulp-cache', 'Must pass a task to cache()');
	}

	var options = _extends({}, plugin.defaultOptions, task.cacheable, inputOptions);

	var taskProxy = new TaskProxy(task, options);

	function each(file, enc, next) {
		var _this = this;

		if (file.isNull()) {
			next(null, file);
			return;
		}

		if (file.isStream()) {
			next(new gulpUtil.PluginError('gulp-cache', 'Cannot operate on stream sources'));
			return;
		}

		var signals = taskProxy.processFile(file);

		signals.on('error', function (err) {
			next(new gulpUtil.PluginError('gulp-cache', err));
		});

		signals.on('file', function (file) {
			_this.push(file);
		});

		signals.on('done', function () {
			next(null);
		});
	}

	function flush(next) {
		taskProxy.flush(next);
	}

	return through.obj(each, flush);
}

plugin.clear = function clear(inputOptions) {
	var each = function () {
		var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(file, enc, next) {
			return _regeneratorRuntime.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							if (!file.isNull()) {
								_context.next = 3;
								break;
							}

							next(null, file);
							return _context.abrupt('return');

						case 3:
							if (!file.isStream()) {
								_context.next = 6;
								break;
							}

							next(new gulpUtil.PluginError('gulp-cache', 'Cannot operate on stream sources'));
							return _context.abrupt('return');

						case 6:
							_context.prev = 6;
							_context.next = 9;
							return taskProxy.removeCachedResult(file);

						case 9:
							next(null, file);
							return _context.abrupt('return');

						case 13:
							_context.prev = 13;
							_context.t0 = _context['catch'](6);

							next(new gulpUtil.PluginError('gulp-cache', _context.t0));
							return _context.abrupt('return');

						case 17:
						case 'end':
							return _context.stop();
					}
				}
			}, _callee, this, [[6, 13]]);
		}));

		return function each(_x, _x2, _x3) {
			return _ref.apply(this, arguments);
		};
	}();

	var options = _extends({}, plugin.defaultOptions, inputOptions);

	var taskProxy = new TaskProxy(null, options);

	return through.obj(each);
};

plugin.clearAll = function clearAll() {
	return new _Promise(function (resolve, reject) {
		fileCache.clear(null, function (err) {

			if (err) {
				reject(new gulpUtil.PluginError('gulp-cache', 'Problem clearing the cache: ' + err.message));
				return;
			}

			resolve();
		});
	});
};
module.exports = exports['default'];

module.exports = plugin;
//# sourceMappingURL=index.js.map
